VERSION 5.00
Object = "{65E121D4-0C60-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCHRT20.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   10695
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   17415
   LinkTopic       =   "Form1"
   ScaleHeight     =   10695
   ScaleWidth      =   17415
   StartUpPosition =   3  'Windows-Standard
   Begin VB.CheckBox chkg 
      Caption         =   "Geschwindigkeit"
      Height          =   255
      Left            =   5280
      TabIndex        =   4
      Top             =   600
      Value           =   1  'Aktiviert
      Width           =   1815
   End
   Begin VB.CheckBox chkh 
      Caption         =   "Hhe"
      Height          =   255
      Left            =   5280
      TabIndex        =   3
      Top             =   240
      Value           =   1  'Aktiviert
      Width           =   1695
   End
   Begin MSComctlLib.StatusBar bar 
      Align           =   2  'Unten ausrichten
      Height          =   375
      Left            =   0
      TabIndex        =   2
      Top             =   10320
      Width           =   17415
      _ExtentX        =   30718
      _ExtentY        =   661
      _Version        =   393216
      BeginProperty Panels {8E3867A5-8586-11D1-B16A-00C0F0283628} 
         NumPanels       =   5
         BeginProperty Panel1 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            AutoSize        =   2
         EndProperty
         BeginProperty Panel2 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            AutoSize        =   2
         EndProperty
         BeginProperty Panel3 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            AutoSize        =   2
         EndProperty
         BeginProperty Panel4 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            AutoSize        =   2
         EndProperty
         BeginProperty Panel5 {8E3867AB-8586-11D1-B16A-00C0F0283628} 
            AutoSize        =   2
         EndProperty
      EndProperty
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
   End
   Begin MSChart20Lib.MSChart chart 
      Height          =   9015
      Left            =   0
      OleObjectBlob   =   "Form1.frx":0000
      TabIndex        =   0
      Top             =   960
      Width           =   12975
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Datei Laden"
      Height          =   615
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   4815
   End
   Begin MSComDlg.CommonDialog dlgCommonDialog 
      Left            =   1080
      Top             =   360
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim file As String


Private Sub readbin(ByVal FileName As String)
  Dim daten() As Byte
  Dim i  As Integer
  Dim hbyte, lbyte As Long
  Dim FNum As Long
  Dim zero_g, vel_z, height, az, ax, interval, last_z, last_x, max_az, max_ax, max_vz, max_h As Double
  Const zero_g_count = 20
  Const counter_int As Double = 1024 / 1000000
  Const g = 9.807
  Const g_per_step = 0.13
  
   FNum = FreeFile
  Open FileName For Binary As #FNum
   ReDim daten(LOF(FNum))
 '  daten = Input(LOF(FNum), #FNum)
   Get #FNum, , daten
  Close #FNum
  chart.RowCount = UBound(daten) \ 4 - 1
  interval = daten(1) * counter_int 's
  bar.Panels.Item(1).Text = "Interval=" + Format(interval * 1000, "#.00") + "ms "
  bar.Panels.Item(2).Text = "Messzeit=" + Format(interval * 512, "#.00") + "s "
  zero_g = 0 'm/s*s
  vel_z = 0 'm/s
  height = 0 'm
  max_az = 0 'm/s*s
  
  For i = 4 To UBound(daten) - 4 Step 4
      chart.Column = 1
      chart.Row = i \ 4
      chart.RowLabel = Format(interval * (i \ 4), "#0.00") + "s"
      
      hbyte = daten(i)
      lbyte = daten(i + 1)
      If (hbyte * 256 + lbyte < 1024) Then
        az = ((hbyte * 256 + lbyte - 512) * g_per_step * g)
        last_z = az
        chart.Data = az
        If Abs(az) > Abs(max_az) Then max_az = az
      Else
        chart.Data = 0
      End If
      chart.Column = 2
      hbyte = daten(i + 2)
      lbyte = daten(i + 3)
      If (hbyte * 256 + lbyte < 1024) Then
        ax = ((hbyte * 256 + lbyte - 512) * g_per_step * g)
        last_x = ax
        chart.Data = ax
        If Abs(ax) > Abs(max_ax) Then max_ax = ax
      Else
        chart.Data = 0
      End If
      chart.Column = 3
      chart.Data = 0
      chart.Column = 4
      chart.Data = 0
      If (i < 4 * zero_g_count) Then
        zero_g = zero_g + az
      Else
        If Abs(az - zero_g / zero_g_count) > 1.5 Then vel_z = vel_z + (az - zero_g / zero_g_count) * interval
        height = height + vel_z * interval
        chart.Column = 3
        chart.Data = vel_z
        If Abs(vel_z) > Abs(max_vz) Then max_vz = vel_z
        If chkg.Value = 0 Then chart.Data = 0
        chart.Column = 4
        chart.Data = height
        If Abs(height) > Abs(max_h) Then max_h = height
        If chkh.Value = 0 Then chart.Data = 0
      End If
  Next i
  bar.Panels.Item(3).Text = "Hhe=" + Format(height, "#.00") + "m "
  bar.Panels.Item(4).Text = "Geschwindigkeit=" + Format(vel_z, "#.00") + "m/s "
  bar.Panels.Item(5).Text = "max_zg=" + Format(max_az / g, "#.00") + "g max_vz=" + Format(max_vz, "#.00") + "m/s max_h=" + Format(max_h, "#.00") + "m "
  chart.Refresh
End Sub


Private Sub chkg_Click()
  If Not file = vbNullString Then readbin file

End Sub

Private Sub chkh_Click()
  If Not file = vbNullString Then readbin file
End Sub

Private Sub Command1_Click()
'   On Error Resume Next
   Dim sFile As String
   With dlgCommonDialog
'        .InitDir = LastPath
        .DialogTitle = "ffnen"
        .CancelError = True
        'Zu erledigen: Festlegen der Flags und Attribute des Standarddialog-Steuerelements
        .Filter = "logger files (.bin)|*.bin|All Files (*.*)|*.*"
        .ShowOpen
        If Len(.FileName) = 0 Or Err Then
            Exit Sub
        End If
        sFile = .FileName
    End With
    readbin sFile
    
    Me.Caption = " [" + sFile + "]"
    file = sFile
End Sub

Private Sub Form_Resize()
On Error Resume Next
chart.height = Me.height - chart.Top - bar.height * 3
chart.Width = Me.Width
End Sub
